#ifndef __TG_12F_H
#define __TG_12F_H 			   
#include "stm32f10x.h"

#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#if defined ( __CC_ARM   )
#pragma anon_unions
#endif




#define TG_12F_RST_Pin          GPIO_Pin_4    //λܽ
#define TG_12F_RST_Pin_Port     GPIOA    //λ 
#define TG_12F_RST_Pin_Periph_Clock  RCC_APB2Periph_GPIOA       //λʱ

#define TG_12F_CH_PD_Pin     GPIO_Pin_5   //ʹܹܽ
#define TG_12F_CH_PD_Pin_Port     GPIOA   //ʹܶ˿
#define TG_12F_CH_PD_Pin_Periph_Clock  RCC_APB2Periph_GPIOA                     //ʹʱ


#define TG_12F_RST_Pin_SetH     GPIO_SetBits(TG_12F_RST_Pin_Port,TG_12F_RST_Pin)
#define TG_12F_RST_Pin_SetL     GPIO_ResetBits(TG_12F_RST_Pin_Port,TG_12F_RST_Pin)


#define TG_12F_CH_PD_Pin_SetH     GPIO_SetBits(TG_12F_CH_PD_Pin_Port,TG_12F_CH_PD_Pin)
#define TG_12F_CH_PD_Pin_SetL     GPIO_ResetBits(TG_12F_CH_PD_Pin_Port,TG_12F_CH_PD_Pin)


#define TG_12F_USART(fmt, ...)  USART_printf (USART2, fmt, ##__VA_ARGS__)    
#define PC_USART(fmt, ...)       printf(fmt, ##__VA_ARGS__)       //Ǵڴӡ1ִprintfԶִfputضprintf



#define RX_BUF_MAX_LEN 1024       //ֽ
extern struct STRUCT_USART_Fram   //֡ṹ
{
    char Data_RX_BUF[RX_BUF_MAX_LEN];
    union 
    {
        __IO u16 InfAll;
        struct 
        {
            __IO u16 FramLength       :15;                               // 14:0 
            __IO u16 FramFinishFlag   :1;                                // 15 
        }InfBit;
    }; 
	
}TG_12F_Fram_Record_Struct;


//ʼ
void TG_12F_Init(u32 bound);
void TG_12F_AT_Test(void);
bool TG_12F_Send_AT_Cmd(char *cmd,char *ack1,char *ack2,u32 time);
void TG_12F_Rst(void);

void TG_12F_SETUP(void);
void TG_12F_net(void);
bool TG_12F_Scan(void);
bool TG_12F_Scan1(void);
void TG_12F_RECVJSON(void);
void USART_printf( USART_TypeDef * USARTx, char * Data, ... );



#endif
