#include "tg_12f.h"
#include "usart.h"
#include "delay.h"
#include "ali.h"
#include "led.h"
#include <stdarg.h>



struct STRUCT_USART_Fram TG_12F_Fram_Record_Struct = { 0 };  //һ֡ṹ
void TG_12F_Init(u32 bound)
{
    GPIO_InitTypeDef GPIO_InitStructure;

    RCC_APB2PeriphClockCmd(TG_12F_RST_Pin_Periph_Clock|TG_12F_CH_PD_Pin_Periph_Clock, ENABLE);

    GPIO_InitStructure.GPIO_Pin = TG_12F_RST_Pin;             
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;     //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;    
    GPIO_Init(TG_12F_RST_Pin_Port, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = TG_12F_CH_PD_Pin;               
    GPIO_Init(TG_12F_CH_PD_Pin_Port, &GPIO_InitStructure);

    uart2_Init(bound); 
	  TG_12F_CH_PD_Pin_SetL;
	  TG_12F_Rst();
}
//TG_12Fģ鷢ATָ
// cmd ͵ָ
// ack1,ack2;ڴӦΪNULLӦΪ߼ϵ
// time ȴӦʱ
//1ͳɹ 0ʧ
bool TG_12F_Send_AT_Cmd(char *cmd,char *ack1,char *ack2,u32 time)
{ 
    TG_12F_Fram_Record_Struct .InfBit .FramLength = 0; //½µݰ
    TG_12F_USART("%s\r\n", cmd);
    if(ack1==0&&ack2==0)     //Ҫ
    {
    return true;
    }
    delay_ms(time);   //ʱ
    TG_12F_Fram_Record_Struct.Data_RX_BUF[TG_12F_Fram_Record_Struct.InfBit.FramLength ] = '\0';
		
    printf("%s",TG_12F_Fram_Record_Struct .Data_RX_BUF);
    if(ack1!=0&&ack2!=0)
    {
        return ( ( bool ) strstr ( TG_12F_Fram_Record_Struct .Data_RX_BUF, ack1 ) || 
                         ( bool ) strstr ( TG_12F_Fram_Record_Struct .Data_RX_BUF, ack2 ) );
    }
    else if( ack1 != 0 )  //strstr(s1,s2);s2ǷΪs1һ֣Ƿظλã򷵻falseǿתΪbool
        return ( ( bool ) strstr ( TG_12F_Fram_Record_Struct .Data_RX_BUF, ack1 ) );

    else
        return ( ( bool ) strstr ( TG_12F_Fram_Record_Struct .Data_RX_BUF, ack2 ) );

}


//λ
void TG_12F_Rst(void)
{
    TG_12F_RST_Pin_SetL;
    delay_ms(500); 
    TG_12F_RST_Pin_SetH;
}


//ͻָĬָģָɳ
void TG_12F_AT_Test(void)
{
	  TG_12F_Send_AT_Cmd("AT+RESTORE","OK",NULL,5000);
}


//Ԫ
/* Product_Key  ƷԿ
 * Device_Name  豸
 * Device_Secret豸ܲ
 * Product_Secret Ʒܲ
 * Product_Id     ƷID
 */
void TG_12F_SETUP(void)
{ 
	  char cCmd[120];
	  sprintf ( cCmd, "AT+LINKKEYCONFIG=\"%s\",\"%s\",\"%s\",\"%s\",\"%s\"",Product_Key,Device_Name,Device_Secret,Product_Secret,Product_Id );
    TG_12F_Send_AT_Cmd(cCmd,"OK",NULL,1000);
}

//Ʒָ
void TG_12F_net(void)
{
  char cStr [20];
	sprintf ( cStr, "AT+ALIBTSMARTCONFIG");
  TG_12F_Send_AT_Cmd(cStr,"OK",NULL,1000);
}

//ƽ̨Ƿ·
void TG_12F_RECVJSON(void)
{
  char cStr [20];
	sprintf ( cStr, "AT+RECVJSON");
  TG_12F_Send_AT_Cmd(cStr,"OK",NULL,100);
}

bool TG_12F_Scan(void)
{
	  if(strstr(TG_12F_Fram_Record_Struct.Data_RX_BUF,"CLOUD CONNECTED"))
		{
			return false;
		}
		return true;
}

bool TG_12F_Scan1(void)
{
	
	if(strstr(TG_12F_Fram_Record_Struct.Data_RX_BUF,"{\"powerstate\":1}"))
	{
			LED_ON();
			return true;
	}
	else if(strstr(TG_12F_Fram_Record_Struct.Data_RX_BUF,"{\"powerstate\":0}"))
	{
			LED_OFF();
			return true;			
	}
	return true;
}


static char *itoa( int value, char *string, int radix )
{
    int     i, d;
    int     flag = 0;
    char    *ptr = string;

    /* This implementation only works for decimal numbers. */
    if (radix != 10)
    {
        *ptr = 0;
        return string;
    }

    if (!value)
    {
        *ptr++ = 0x30;
        *ptr = 0;
        return string;
    }

    /* if this is a negative value insert the minus sign. */
    if (value < 0)
    {
        *ptr++ = '-';

        /* Make the value positive. */
        value *= -1;

    }

    for (i = 10000; i > 0; i /= 10)
    {
        d = value / i;

        if (d || flag)
        {
            *ptr++ = (char)(d + 0x30);
            value -= (d * i);
            flag = 1;
        }
    }

    /* Null terminate the string. */
    *ptr = 0;

    return string;

} /* NCL_Itoa */


void USART_printf ( USART_TypeDef * USARTx, char * Data, ... )
{
    const char *s;
    int d;   
    char buf[16];


    va_list ap;
    va_start(ap, Data);

    while ( * Data != 0 )     // жǷ񵽴
    {                                         
        if ( * Data == 0x5c )  //'\'
        {                                     
            switch ( *++Data )
            {
                case 'r':                                     //س
                USART_SendData(USARTx, 0x0d);
                Data ++;
                break;

                case 'n':                                     //з
                USART_SendData(USARTx, 0x0a);   
                Data ++;
                break;

                default:
                Data ++;
                break;
            }            
        }

        else if ( * Data == '%')
        {                                     
            switch ( *++Data )
            {               
                case 's':                                         //ַ
                s = va_arg(ap, const char *);
                for ( ; *s; s++) 
                {
                    USART_SendData(USARTx,*s);
                    while( USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET );
                }
                Data++;
                break;

                case 'd':           
                    //ʮ
                d = va_arg(ap, int);
                itoa(d, buf, 10);
                for (s = buf; *s; s++) 
                {
                    USART_SendData(USARTx,*s);
                    while( USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET );
                }
                     Data++;
                     break;
                default:
                     Data++;
                     break;
            }        
        }
        else USART_SendData(USARTx, *Data++);
        while ( USART_GetFlagStatus ( USARTx, USART_FLAG_TXE ) == RESET );

    }
}
